common_config:
  region: us-east-1
  allowed_account_ids:
    - 1234567890123
  default_tags:
    env: dev
    project: labs

## This configuration file will provision a single instance.
## It will a create ssh key-pair and store it in a s3-bucket in the given path
## Note: Bucket should be in the same region mentioned in common_config
## It will also create a security group with speicified rules.
## Route53 records with record type 'A' will be created.
## remote-exec functionality is also available

ec2_conf:
  single-instance:
    instance_type: t2.micro
    ami: ami-0c691e4a2a2f86196
    monitoring: true
    vpc_security_group_ids:
      - "sg-0933fd01b91ec9f5c"
    subnet_id: "subnet-07c1778c0f1d00aba"

    ## Creating SSH Key Pair
    create_ssh_key_pair: true
    key_name: "test_keypair"
    ssh_key_bucket_name: test-terraform-bucket
    key_storage_path: /keys

    ## Creating Security Group
    create_security_group: true
    security_group_name: test-sg
    vpc_id: vpc-0569231405c44b0aa
    security_group_egress_rules:
      - from_port: 0
        to_port: 0
        protocol: "-1"
        cidr_blocks:
          - "0.0.0.0/0"
    security_group_ingress_rules:
      - from_port: 80
        to_port: 80
        protocol: "tcp"
        cidr_blocks:
          - "0.0.0.0/0"
      - from_port: 22
        to_port: 22
        protocol: "tcp"
        cidr_blocks:
          - "0.0.0.0/0"

    ## Creating Route53 record
    create_route53_record: true
    route53_zone_name: example.com
    route53_record_name: instance.example.com
    route53_record_ttl: 90

    ## remote_exec config
    remote_exec_code: echo Hello World!
    ssh_user: ubuntu
    remote_exec_using_public_ip: true
    hold_remote_exec_for_sec: "10"
    ssh_connection_timeout: 30
    ssh_script_path: "./ssh_script"
    tags:
      Terraform: "true"
